<?php

namespace ImageBundle\Repository;


use Psr\Log\LoggerInterface;
use Schema\SchemaEntityRepository;
use ImageBundle\Entity\PictureFrame;
use Doctrine\Common\Persistence\ManagerRegistry;
use Utils\StaticUtil\LogUtils;


/**
 * PictureFrameRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class PictureFrameRepository extends SchemaEntityRepository {

    /** @var LoggerInterface $logger */
    private $logger;

    /**
     * PictureFrameRepository constructor.
     * @param ManagerRegistry $registry
     * @param LoggerInterface $logger
     */
    public function __construct(ManagerRegistry $registry, LoggerInterface $logger) {
        parent::__construct($registry, PictureFrame::class);
        $this->logger = $logger;
    }

    /**
     * @param int $type
     * @return array|mixed
     */
    public function findActivesByType ($type) {

        $qb = $this->getEntityManager()->createQueryBuilder();
        $qb->select('pf')
            ->from('ImageBundle:PictureFrame', 'pf')
            ->where('(pf.isDisabled IS NULL OR pf.isDisabled=0) AND pf.type=:type')
            ->setParameter('type', $type)
        ;

        $results = array();

        try {
            $results = $qb->getQuery()->getResult();
        } catch (\Exception $e) {
            $exception = LogUtils::getFormattedExceptions($e);
            $this->logger->error("Failed get active picture frames by type: ".$type, $exception);
        }

        return $results;
    }

    /**
     * @param $type
     * @return mixed|null
     */
    public function findDefaultByType ($type) {

        $qb = $this->getEntityManager()->createQueryBuilder();
        $qb->select('pf')
            ->from('ImageBundle:PictureFrame', 'pf')
            ->where('(pf.isDisabled IS NULL OR pf.isDisabled=0) AND pf.isDefault=1 AND pf.type=:type')
            ->setParameter('type', $type)
        ;

        $result = null;

        try {
            $result = $qb->setMaxResults(1)->getQuery()->getOneOrNullResult();
        } catch (\Exception $e) {
            $exception = LogUtils::getFormattedExceptions($e);
            $this->logger->error("Failed get default pic frame by type", $exception);
        }

        return $result;
    }


}
